//This big hack demonstrates 
//hagphysics2d.h 12/4/05

// Jim Sinha fuzinavl@hotmail.com 


//#include <cstdlib>
#include <iostream> // for cout <<

#include <OpenLayer.hpp> // for allegro, allegroGL, buncha' other stuff
#include "hagphysics2d.h"
#include "hagutil.h" // for distance(,,,);


using namespace ol;
using namespace std;


struct SpaceDust
{
   float ax,ay,vx,vy;
   float x,previous_x;    
   float y,previous_y;
   Rgba color;
};



int main(int argc, char *argv[])
{

// INITIALIZATION //

Setup::SetupProgram();
Setup::SetupScreen( 600, 600, WINDOWED );
FpsCounter::Start( 1.0 ); // dt is dt per 1.0 seconds


const int num_dust = 1000;
SpaceDust dust[num_dust];
for(int i=0; i < num_dust; i++)
{
   dust[i].ax = dust[i].ay = dust[i].vx = dust[i].vy = 0;
   dust[i].x = dust[i].previous_x = rand()%600;
   dust[i].y = dust[i].previous_y = rand()%600;
   dust[i].previous_x += 2; // so we can see the dots
   dust[i].color = Rgba(rand()%256,rand()%256,rand()%256);
}


while( !key[KEY_ESC] )
{

   FpsCounter::NewFrameStarted();
   float fps = FpsCounter::GetFps();
   float dt = FpsCounter::GetDeltaTime();    

           
for(int i=0; i < num_dust; i++)
{
   dust[i].ax = 0;  dust[i].ay = 0; //reset accelerations every frame

   gravity( dust[i].ax, dust[i].ay, dust[i].x, dust[i].y, 
            mouse_x, mouse_y, 170000.0, true);           
   gravity( dust[i].ax, dust[i].ay, dust[i].x, dust[i].y, 
            mouse_x, mouse_y+100, 170000.0, true);           

   linear_acceleration(dust[i].x, dust[i].vx, dust[i].ax, dt);    
   linear_acceleration(dust[i].y, dust[i].vy, dust[i].ay, dt);    
   

                //Use AFTER linear_acceleration();
   speed_limit2d(dust[i].vx, dust[i].vy, dust[i].x, dust[i].y, 
                 dust[i].previous_x, dust[i].previous_y,
                 1*600, dt); // 1 second to cross the screen
   
   //Your collision detection code goes here
                
   if (dust[i].x < 0) dust[i].y = dust[i].previous_y = dust[i].x = dust[i].previous_x = 500; 
   if (dust[i].y < 0) dust[i].x = dust[i].previous_x = dust[i].y = dust[i].previous_y = 500; 
   if (dust[i].x >= 600) dust[i].y = dust[i].previous_y = dust[i].x = dust[i].previous_x = 500; 
   if (dust[i].y >= 600) dust[i].x = dust[i].previous_x = dust[i].y = dust[i].previous_y = 500;      
   if (10 > distance(dust[i].x,dust[i].y,mouse_x,mouse_y))
      dust[i].x = dust[i].previous_x = dust[i].y = dust[i].previous_y = 500;
   if (10 > distance(dust[i].x,dust[i].y,mouse_x,mouse_y+100))
      dust[i].x = dust[i].previous_x = dust[i].y = dust[i].previous_y = 500;
} 
// for(int i=0; i < num_dust; i++)



cout << "fps " << fps << endl,



   // RENDERING //
      
   // Clear the screen to white //
   GfxRend::FillScreen( Rgba::WHITE );

   for(int i=0; i < num_dust; i++)
   {
      GfxRend::LineGradient( dust[i].x, dust[i].y, 
                             dust[i].previous_x, dust[i].previous_y, 
                             dust[i].color, 
                             Rgba(0.0,0.0,0.0,0.0) );
                             
      dust[i].previous_x = dust[i].x;
      dust[i].previous_y = dust[i].y;
   }

   GfxRend::Circle( mouse_x, mouse_y, 10.0, Rgba::RED );
   GfxRend::Circle( mouse_x, mouse_y+100, 10.0, Rgba::BLACK );

   // Refresh the screen contents to show this frame //
   GfxRend::RefreshScreen();

}
// while( !key[KEY_ESC] )

    return EXIT_SUCCESS;
}
END_OF_MAIN()


















