/*
To do:
test force_duration vars on paper
find out how to apply linear_acceleration(); to turning      
? platform friction
? friction between stacked objects

features:
+ utility function also determine post-collision velocity and angular speed
+ utility function: return center of mass and angular mass for adding masses
? utility function: platform friction
? utility function: friction between stacked objects
+ utility function: effects of an off-center force on a 2d mass
*/

#ifndef HAGPHYSICS2D_H

            //position & velocity receive new values
void linear_acceleration(float &position, float &velocity,  
                         float acceleration, float dt=1.0f);

             //Use AFTER linear_acceleration();
void speed_limit1d(float &velocity, float &position, 
                   float previous_position, 
                   float speed_limit, float dt=1.0f);

             //Use AFTER linear_acceleration();
void speed_limit2d(float &vx, float &vy, float &x, float &y, 
                   float previous_x, float previous_y,
                   float speed_limit, float dt=1.0f);
                       
                            
void gravity( float &ax, float &ay, 
              float x, float y, 
              float planet_x, float planet_y, float gravity_constant,
              bool linear_gravity = false); //default a = G / (dist*dist)
                                    
                         
           //acceleration and angular_acceleration will receive new values
           //everything in LOCAL COORDINATES relative to body of mass at 0 degrees
           //useful for attached rocket thrusters
void add_mounted_force(float &acc_x, float &acc_y, float &angular_acceleration,
         float mass, float angular_mass, float body_angle,
         float mount_point_x, float mount_point_y, //relative to center of mass
         float force_angle, float force_magnitude);
         
                                                                    
           //acceleration and angular_acceleration will receive new values
           //everything in WORLD COORDINATES
           //useful for things like tractor beams, bungee cords
void add_force(float &acc_x, float &acc_y, float &angular_acceleration,
         float mass, float angular_mass,
         float force_x, float force_y, //world coords relative to center of mass
         float force_x_direction, float force_y_direction, //magnitude ignored here
         float force_magnitude);


         //mass1,comx1,comy1 will receive new values
void add_mass(float &mass1, float &comx1, float &comy1,
                float mass2, float comx2, float comy2); //com = "center of mass"


/* NOT IMPLEMENTED:

         //mass1,angular_mass1,comx1,comy1 will receive new values
void add_mass(float &mass1, float &angular_mass1, float &comx1, float &comy1, 
                float mass2, float comx2, float comy2); //com = "center of mass"

             //Calculate velocity for 2 bodies post-collision 
             //mass1,angular_mass1,comx1,comy1 will receive new values
void elastic_collision( float &vx1, float &vy1, float mass1, //3 vars
             float &vx2, float &vy2, float mass2, //3 vars
             float impact_normal); //1 var

             //Calculate velocity and rotation for 2 bodies post-collision 
             //vx1,vy1,angular_v1,vx2,vy2,angular_v2 will receive new values
void elastic_collision( float &vx1, float &vy1, float &angular_v1, //3 vars
             float mass1, float angular_mass1, float comx1, float comy1, //4 vars
             float &vx2, float &vy2, float &angular_v2, //3 vars
             float mass2, float angular_mass2, float comx2, float comy2, //4 vars
             float impactx, float impacty, float impact_normal); //3 vars

*/

// ??? inelastic collisions
// ??? inelastic collisions with spin

#define HAGPHYSICS2D_H
#endif          /* ifndef HAGPHYSICS2D_H */



/* How-to Guide:

dt  timeslice

m   mass
mr  rotational-mass

p   position
x   x-position
y   y-position

v   velocity
vx  x-velocity
vy  y-velocity
vr  rotational-velocity

a   acceleration
ax  x-acceleration
ay  y-acceleration
ar  rotational-acceleration

f   force-magnitude (can be + or -)
fx  point of force-application x-component
fy  point of force-application y-component

comx  center-of-mass x-component
comy  center-of-mass y-component

*_angle   expressed in PI radians
*_normal  expressed in PI radians


          
UPDATE POSITION AND ANGLE IN A GAME WITHOUT ACCELERATION:
       ship.x += ship.vx * dt;
       ship.y += ship.vy * dt;
       ship.angle += ship.ar * dt;

CALCULATE FINAL 2D POSITION WITH 2D ACCELERATION
   linear_acceleration(ship.x, ship.vx, ship.ax, dt);    
   linear_acceleration(ship.y, ship.vy, ship.ay, dt);    

CALCULATE CURRENT ANGLE WITH ANGULAR ACCELERATION
   linear_acceleration(ship.angle, ship.vr, ship.ar, dt);    
   
BOTH
   linear_acceleration(ship.x, ship.vx, ship.ax, dt); //step order not important    
   linear_acceleration(ship.y, ship.vy, ship.ay, dt);    
   linear_acceleration(ship.angle, ship.vr, ship.ar, dt);    

ADD A FORCE WITHOUT ROTATION
   ax += force_x_component / mass;
   ay += force_y_component / mass;


COMBINING OFF-CENTER FORCES ON A 2D MASS
note: the gravity and bungee methods shown add error to the results.
You can reduce error by taking smaller dt steps (e.g. 6 per animation frame).
Error can be completely minimized with calculus. (aka making your own physics lib)


ATTACHING SPACE BARNICLES TO OUR SHIP


2 ASTEROIDS BOUNCING OFF OF EACH OTHER


2 ASTEROIDS BOUNCING OFF OF EACH OTHER WITH SPIN


*/











