
/*
                    H.A.G. utilities

         by James Sinha       fuzinavl@hotmail.com

               http://fuzinavl.tripod.com/

*/

#include "hagutil.h"

#include<cmath>

float distance(float x1, float y1,float x2,float y2)
{
   return sqrt( (x2-x1)*(x2-x1) + (y2-y1)*(y2-y1) );
}



void normalize_vector( float &x, float &y )
{
     float angle = atan2(y,x);
     x = cos(angle);
     y = sin(angle);
}


/* ******************** unimplemented: *********************

void wrap_add(int &number1, int number2, int ceiling);
     //useful for adjusting a sprite rotation state / angles using table lookup
     //can add or subtract values
     //setting ceiling to 4 makes number1 become 0,1,2,or 3 

void wrap_add(float &number1, int number2, int ceiling);
     //useful for keeping angles between 0 and 2*PI
     //can add or subtract values
     //setting ceiling to 4 makes number1 become 0,1,2,or 3 
*/
     

//**************************************************************
//                 Function Interfaces
//**************************************************************

/*

void polygon_force_CW( int *verts, int num_verts);
     // useful for level editors of games using simplelos or monolos

void polygon_force_CCW( int *verts, int num_verts);

bool polygon_is_CW( int *verts, int num_verts);




int polygon_area( int *verts, int num_verts);  //returns negative or positive values

void swap(int *, int *);

void reverse_verts(int *verts, int num_verts);


*/




/* ******************** unimplemented: *********************

     
bool on_right( int line_x1, int line_y1, int line_x2, int line_y2,
               int point_x, int point_y); 
   // is a point on the right side of an upward line segment? 


*/


//**************************************************************
//                 Function Definitions
//**************************************************************

/*

void swap(int *num1, int *num2)
{
  int temp = *num1;
  *num1 = *num2;
  *num2 = temp;
}

void reverse_verts(int *verts, int num_verts)
{
  for(int i=0; i< num_verts/2; i++) {
    swap( &verts[i*2], &verts[(num_verts-i -1)*2 ] );  //x-values
    swap( &verts[i*2 +1], &verts[(num_verts-i -1)*2 +1] ); //y-values
  }
}



	//returns negative or positive values
int polygon_area(int *verts, int num_verts)  
{
   int i,j;
   int area = 0;

   for (i=0; i<num_verts; i++) {
      j = (i + 1) % num_verts;
      area += verts[i*2] * verts[j*2+1]; //polygon[i].x * polygon[j].y;
      area -= verts[i*2+1] * verts[j*2]; //polygon[i].y * polygon[j].x;
   }

   area /= 2;	//only loss of precision is here

   return(area);
}


bool polygon_is_CW(int *verts, int num_verts)
{
  if(0 <= polygon_area(verts,num_verts))
    return true;
  else
    return false;
}

void polygon_force_CW( int *verts, int num_verts)
{
  if( ! polygon_is_CW( verts, num_verts))
    reverse_verts( verts, num_verts);

}


void polygon_force_CCW( int *verts, int num_verts)
{
  if( polygon_is_CW( verts, num_verts))
    reverse_verts( verts, num_verts);

}

*/

/* ******************** unimplemented: *********************


void wrap_add(int *number1, int number2, int ceiling)
{
   *number1 += number2;

   if(*number1 < 0)
   {
      if(*number1 % (ceiling) == 0) *number1 = 0;
      else *number1 = ceiling + (*number1 % (ceiling));
   }  
              
   else *number1 %= (ceiling);
}//end void wrap_add(int *number1, int number2, int ceiling)


// is a point on the right side of an upward line? 
bool on_right( int x1, int y1,   // line segment 
		     int x2, int y2,

		     int x3, int y3)   // point 
{
    int a1, b1, c1; // Coefficients of line eqns. 
    int r3;         // 'Sign' values 

    // Compute a1, b1, c1, where line joining points 1 and 2
    // is "a1 x  +  b1 y  +  c1  =  0".
     
    a1 = y2 - y1;
    b1 = x1 - x2;
    c1 = x2 * y1 - x1 * y2;

    // Compute result
     
    r3 = a1 * x3 + b1 * y3 + c1;
    
    if(r3 >= 0) return false;
    else return true;
}//end bool on_right(line,,,,point,)



//CENTROID

public Point2Df PolygonCenterOfMass(Point[] polygon,int N)
{
	float cx=0,cy=0;
	float A=(float)PolygonArea(polygon,N);
	Point2Df res=new Point2Df();
	int i,j;

	float factor=0;
	for (i=0;i<N;i++) {
		j = (i + 1) % N;B B B B B B B 
		factor=(polygon[i].x*polygon[j].y-polygon[j].x*polygon[i].y);
		cx+=(polygon[i].x+polygon[j].x)*factor;
		cy+=(polygon[i].y+polygon[j].y)*factor;B B B B B B B B B B B 
	}
	A*=6.0f;
	factor=1/A;
	cx*=factor;
	cy*=factor;
	res.x=cx;
	res.y=cy;
	return res;
}
*/



