//This big hack demonstrates 
//hagphysics2d.h 12/1/05

// Jim Sinha fuzinavl@hotmail.com 


//#include <cstdlib>
#include <cmath> // for M_PI
#include <iostream> // for cout <<

#include <OpenLayer.hpp> // for allegro, allegroGL, buncha' other stuff
#include "hagphysics2d.h"
#include "hagutil.h" // for distance(,,,);


using namespace ol;
using namespace std;

struct Thruster
{
   float x,y,angle,force; //always ship-relative
   bool on;
};

struct Ship
{
float radius;  //extremely complex hull here ;)
float ax,ay,ar,vx,vy,vr,angle,previous_angle; //0
float m,mr;
float x,previous_x;    
float y,previous_y;
Thruster thruster1;
Thruster thruster2;      
};


int main(int argc, char *argv[])
{

// INITIALIZATION //

Ship ship;
ship.radius = 30;
ship.ax = ship.ay = ship.ar = ship.vx = ship.vy = ship.vr = ship.angle = 0;
ship.previous_angle = 0;
ship.m = 1;
ship.mr = 5; // moment of inertia: disk I = m*r*r/2 , but we use fake # here
ship.x = ship.previous_x = 300;
ship.y = ship.previous_y = 300;

ship.thruster1.y = ship.thruster2.y = 0;
ship.thruster1.x = -20;
ship.thruster2.x = 20;
ship.thruster1.angle = ship.thruster2.angle = - M_PI/2;
ship.thruster1.force = ship.thruster2.force = 240;
ship.thruster1.on = ship.thruster2.on = false;


Setup::SetupProgram();
Setup::SetupScreen( 600, 600, WINDOWED );
FpsCounter::Start( 1.0 ); // dt is dt / 1.0 seconds


while( !key[KEY_ESC] )
{
   FpsCounter::NewFrameStarted();
   float fps = FpsCounter::GetFps();
   float dt = FpsCounter::GetDeltaTime();
   
   // INPUT //
   if( key[KEY_Q] ) ship.thruster1.on = true; //realistic-ish
   if( key[KEY_E] ) ship.thruster2.on = true;
   if( !key[KEY_Q] ) ship.thruster1.on = false; //realistic-ish
   if( !key[KEY_E] ) ship.thruster2.on = false;    

   if( key[KEY_W] ) ship.thruster1.on = ship.thruster2.on = true; //full thrust     

   if( key[KEY_A] ) {ship.angle -= 0.07; ship.vr = 0.0;} //gyroscopic turning
   if( key[KEY_D] ) {ship.angle += 0.07; ship.vr = 0.0;} //mode    

   if( key[KEY_S] ) ship.vx = ship.vy = ship.vr = 0.0; //full stop    

              
   ship.ax = 0;  ship.ay = 0;  ship.ar = 0; //reset accelerations every frame
   
   if(ship.thruster1.on == true)
      add_mounted_force(ship.ax, ship.ay, ship.ar,
                        ship.m, ship.mr, ship.angle,
                        ship.thruster1.x, ship.thruster1.y, //ship-relative
                        ship.thruster1.angle, ship.thruster1.force); //ship-relative
   if(ship.thruster2.on == true)
      add_mounted_force(ship.ax, ship.ay, ship.ar,
                        ship.m, ship.mr, ship.angle,
                        ship.thruster2.x, ship.thruster2.y, //ship-relative
                        ship.thruster2.angle, ship.thruster2.force); //ship-relative

   if(mouse_b & 2)  
      gravity( ship.ax, ship.ay, ship.x, ship.y, 
               mouse_x, mouse_y, 1000000.0, true); //"true" for gameplay reasons
               
   // we also have a bungee cord between the ship center and the mouse cursor
   // everything is in WORLD coordinates
   
   if(mouse_b & 1)
      add_force(ship.ax, ship.ay, ship.ar,
                ship.m, ship.mr, 0, 0,
                mouse_x - ship.x, mouse_y - ship.y, 
                20 * distance(ship.x, ship.y, mouse_x, mouse_y) );
                //spring_coefficient = 20 per pixel length increase
                
             
   //we've added all forces in the scenario
   //now update ship position and rotation as the final step:
   linear_acceleration(ship.x, ship.vx, ship.ax, dt);    
   linear_acceleration(ship.y, ship.vy, ship.ay, dt);    
   linear_acceleration(ship.angle, ship.vr, ship.ar, dt);
   

             //Use AFTER linear_acceleration();
   speed_limit2d(ship.vx, ship.vy, ship.x, ship.y, 
                 ship.previous_x, ship.previous_y,
                 4*600, dt); // 1 second to cross the screen 4 times
                      
                           cout << "speed\t" << distance(0,0,ship.vx,ship.vy);
                                   
             //Use AFTER linear_acceleration();
   speed_limit1d( ship.vr, ship.angle, ship.previous_angle, 
                  6 * (2*M_PI), dt); // six 360's / second maximum
                   
                           cout << "\t360s/sec\t" << ship.vr / (2*M_PI);
                           cout << "\tfps\t" << fps << "\tdt\t" << dt << endl;  
 
  
   //Your collision detection code goes here


   if (ship.x < 0) ship.x += 600; //screen wrap-around
   if (ship.y < 0) ship.y += 600; //screen wrap-around
   if (ship.x >= 600) ship.x -= 600; //screen wrap-around
   if (ship.y >= 600) ship.y -= 600; //screen wrap-around
   
   ship.previous_x = ship.x; //you'll probably want this 
   ship.previous_y = ship.y; //for next frame's collision detection
   ship.previous_angle = ship.angle;
   
   // RENDERING //
      
   // Clear the screen to white //
   GfxRend::FillScreen( Rgba::BLACK );

   
   GfxRend::Circle( ship.x, ship.y, 30.0, Rgba(0.3,0.3,0.3) );
   GfxRend::Circle( ship.x + 22 * cos(ship.angle - M_PI/2), 
                    ship.y + 22 * sin(ship.angle - M_PI/2), 
                    10.0, Rgba(0.0,1.0,1.0) );

   if(ship.thruster1.on == true)
      GfxRend::Circle( ship.x + ship.thruster1.x * cos(ship.angle), 
                       ship.y + ship.thruster1.x * sin(ship.angle),
                       5.0, Rgba::RED );
   if(ship.thruster2.on == true)
      GfxRend::Circle( ship.x + ship.thruster2.x * cos(ship.angle), 
                       ship.y + ship.thruster2.x * sin(ship.angle), 
                       5.0, Rgba::RED );

   if(mouse_b & 2)  
   GfxRend::Circle( mouse_x, mouse_y, 20.0, Rgba(0.0,0.5,0.0) );
   

   GfxRend::Circle( mouse_x, mouse_y, 5.0, Rgba::GREEN );
   if(mouse_b & 1)
      GfxRend::Line( ship.x, ship.y, mouse_x, mouse_y, Rgba(1.0,1.0,1.0,0.5) ); 
                    
   // Refresh the screen contents to show this frame //
   GfxRend::RefreshScreen();

}
// while( !key[KEY_ESC] )

    return EXIT_SUCCESS;
}
END_OF_MAIN()


















